//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB BBDSoft ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================

#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _PCICURS_
   #include "pcicurs.hpp"
#endif

using namespace Uniio;

//-----------------------------------------------------------------------------
PCICursor::PCICursor ()
   : theIterator (PCIBus::pciBus().thePCIDeviceList.begin())
{
BFUNCTRACE_DEVELOP ();

} // end PCICursor constructor

//-----------------------------------------------------------------------------
bool PCICursor::isValid () const
{
BFUNCTRACE_DEVELOP ();
return theIterator != PCIBus::pciBus().thePCIDeviceList.end();
} // PCICursor::isValid () 


//-----------------------------------------------------------------------------
PCICursor & PCICursor::first()
{
BFUNCTRACE_DEVELOP ();
theIterator = PCIBus::pciBus().thePCIDeviceList.begin();
return * this;
} // end PCICursor::first()


//-----------------------------------------------------------------------------
PCICursor & PCICursor::next()
{
BFUNCTRACE_DEVELOP ();
theIterator++;
return * this;
} // end PCICursor::next()


//-----------------------------------------------------------------------------
const PCIDeviceInfo & PCICursor::deviceAtCursor () const
{
BFUNCTRACE_DEVELOP ();
return * (*theIterator);
} // end PCICursor::deviceAtCursor ()